using System;
//using System.Collections.Generic;
using System.Text;

namespace OverloadedOps
{

	public class Point 
	{ 
		private int x, y; 
		public Point() {}
		public Point(int xPos, int yPos) 
		{ 
			x = xPos; 
			y = yPos; 
		} 

		public override bool Equals(object o) 
		{ 

			if (o is Point) 
			{ 
				if (((Point)o).x == this.x && 
					((Point)o).y == this.y) 
					return true; 

			} 
			return false; 

		} 

		public override int GetHashCode() 
		{ 

			return this.ToString().GetHashCode(); 
		} 
		// Now let's overload the == and != operators. 
		public static bool operator ==(Point p1, Point p2) 
		{ 

			return p1.Equals(p2); 
		} 
		public static bool operator !=(Point p1, Point p2) 
		{ 

			return !p1.Equals(p2); 
		} 



		public override string ToString() 
		{ 
			return ("X pos: " + this.x + "  Y pos: " + this.y); 
		} 
	} 
	
	class Class1
	{
		static int Main(string[] args) 
		{ 
			Console.WriteLine("***** Fun with Overloaded Operators *****\n"); 

			// Make two points
			Point ptOne = new Point(100, 100);
			Point ptTwo = new Point(40, 40);
			Console.WriteLine("ptOne = {0} ", ptOne);
			Console.WriteLine("ptTwo = {0} ", ptTwo);

			if (ptOne == ptTwo) 
				Console.WriteLine("Same values "); 
			else 
				Console.WriteLine("Nope, different values "); 


			if (ptOne != ptTwo) 
				Console.WriteLine("These are not equal "); 
			else 
				Console.WriteLine("Nope, Same values "); 

			Console.ReadLine();

			return 0; 
		} 	
	}
}
